/* 
 This function is intended for run of test cases on the host computer.
*/
#include <stdio.h>
#include <string.h>
#include "run.h"

char * dtostre (double val, char *s, unsigned char prec, unsigned char flags)
{
    char fmt[8];
    char sign[2];
    char e;
    
    if (prec > 7) prec = 7;
    
    strcpy(sign, "");
    if (flags & DTOSTR_ALWAYS_SIGN)
	strcpy(sign, " ");
    if (flags & DTOSTR_PLUS_SIGN)
	strcpy(sign, "+");

    e = (flags & DTOSTR_UPPERCASE) ? 'E' : 'e';

    sprintf(fmt, "%%%s.%d%c", sign, prec, e);
    sprintf(s, fmt, val);
    return s;
}
