#ifdef	__AVR__
#  include <avr/pgmspace.h>
#else
#  define PROGMEM
#endif

struct dtostre_s {
    union {
	long lo;
	float fl;
    };
    unsigned char prec;
    unsigned char flags;
    char pattern[15];
};

void run_dtostre (const struct dtostre_s *, int testno);

#ifndef	__AVR__

#define DTOSTR_ALWAYS_SIGN 0x01        /* put '+' or ' ' for positives */
#define DTOSTR_PLUS_SIGN   0x02        /* put '+' rather than ' ' */
#define DTOSTR_UPPERCASE   0x04        /* put 'E' rather 'e' */

char * dtostre (double val, char *s, unsigned char prec, unsigned char flags);

#endif
